<?php
	/*
	Plugin Name: WPRS Anonymous
    Plugin URI: http://authorhreview.com
    Description: Allow anonymous user aggregate reviews. An add-on for the WP Rich Snippets plugin.
    Version: 1.2
    Author: Hesham Zebida
    Author URI: http://zebida.com
    Last Version update : 21 June 2015
	Text Domain: wprs-anonymous
    */
	
	if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly
	
	// plugin version, used to add version for scripts and styles
	define( 'WPRSANONY_VER', '1.2' );
	define( 'WPRSANONY_PLUGIN_NAME', 'WPRS Anonymous' );
	define( 'WPRSANONY_PLUGIN_DOWNLOAD_NAME', 'Anonymous User Reviews' );
	if ( ! defined( 'WPRICHSNIPPETS_WEBSITE_URL' ) ) define( 'WPRICHSNIPPETS_WEBSITE_URL', 'http://wprichsnippets.com' );
			
	// ------------------------------------------------------------------------
	// REQUIRES
	// ------------------------------------------------------------------------
	require_once ('inc/admin/settings.php');								// load admin settings
	require_once ('inc/admin/updater.php');									// load updater
	require_once ('inc/functions.php');										// load functions

	
	// check if WP Reviews is active
	function wprsanony_detect_wprs()  {
		$xplugin = 'wp-rich-snippets/wp-rich-snippets.php';
		$plugin = plugin_basename( __FILE__ );
		if ( !is_plugin_active($xplugin) ) {
			// display notice if plugin isn't active
			add_action('admin_notices', 'wprsanony_my_admin_notice');
			// deactivate
			deactivate_plugins( $plugin );
		}
	}
	add_action( 'admin_init', 'wprsanony_detect_wprs' );
	
	// the notice
	function wprsanony_my_admin_notice(){
		echo '<div class="update-nag"><p>The <a href="http://authorhreview.com/plugins/wp-rich-snippets/" title="WordPress Rich Snippets Plugin" target="_blank" >WP Rich Snippets</a> plugin is required. Plugin has been deactivated!</p></div>';
	}


	// localization
	add_action('init', 'wprsanony_localization_init');
	/*
		load textdomain for internationalization.
		*/
	function wprsanony_localization_init() {
	
		$path = dirname(plugin_basename( __FILE__ )) . '/inc/languages/';
		$loaded = load_plugin_textdomain('wprs-anonymous', false, $path);
		if(isset($_GET['page'])) {
			if ($_GET['page'] == basename(__FILE__) && !$loaded) {          
				echo '<div class="error">WPRS Anonymous: ' . __('Could not load the localization file: ' . $path, 'wprs-anonymous') . '</div>';
				return;
			}
		}
	
	}


// Add-on updates
add_action( 'admin_init', 'wprsanony_sl_updater', 0 );
/**
 * Check for add-ons updates
 *
 * @uses wprsanony_sl_updater()
 *
 * @since 1.2
 */
function wprsanony_sl_updater() {
	
	// get options
	$options = get_option('wprsanony_options');
		
	// Retrieve license key from the DB
	$license = trim( $options['wprsanony_license_key']);
	

	// Setup the updater
	$edd_updater = new WPRS_SL_Plugin_Updater( WPRICHSNIPPETS_WEBSITE_URL, __FILE__, array( 
			'version' 	=> WPRSANONY_VER, 						// current version number
			'license' 	=> $license, 						// license key (used get_option above to retrieve from DB)
			'item_name' => WPRSANONY_PLUGIN_DOWNLOAD_NAME, 	// name of this add-on
			'author' 	=> 'Hesham Zebida'  				// author of this add-on
		)
	);

}
